<?php
if ( ! class_exists( 'Roofing_Specialist_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Roofing_Specialist_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Roofing_Specialist_Plugin_Activation_WPElemento_Importer {

        private static $roofing_specialist_instance;
        public $roofing_specialist_action_count;
        public $roofing_specialist_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$roofing_specialist_instance) ) {
            self::$roofing_specialist_instance = new self();
          }
          return self::$roofing_specialist_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'roofing_specialist_recommended_plugins', array($this, 'roofing_specialist_recommended_elemento_importer_plugins_array') );

            $roofing_specialist_actions                   = $this->roofing_specialist_get_recommended_actions();
            $this->roofing_specialist_action_count        = $roofing_specialist_actions['count'];
            $this->roofing_specialist_recommended_actions = $roofing_specialist_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function roofing_specialist_recommended_elemento_importer_plugins_array($roofing_specialist_plugins){
            $roofing_specialist_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'roofing-specialist'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'roofing-specialist'),               
            );
            return $roofing_specialist_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'roofing-specialist-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('roofing-specialist-plugin-activation-script', 'roofing_specialist_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'roofing-specialist'),
                    'activating' => esc_html__('Activating', 'roofing-specialist'),
                    'error' => esc_html__('Error', 'roofing-specialist'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'roofing-specialist-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function roofing_specialist_get_recommended_actions() {

            $roofing_specialist_act_count  = 0;
            $roofing_specialist_actions_todo = get_option( 'recommending_actions', array());

            $roofing_specialist_plugins = $this->roofing_specialist_get_recommended_plugins();

            if ($roofing_specialist_plugins) {
                foreach ($roofing_specialist_plugins as $roofing_specialist_key => $roofing_specialist_plugin) {
                    $roofing_specialist_action = array();
                    if (!isset($roofing_specialist_plugin['slug'])) {
                        continue;
                    }

                    $roofing_specialist_action['id']   = 'install_' . $roofing_specialist_plugin['slug'];
                    $roofing_specialist_action['desc'] = '';
                    if (isset($roofing_specialist_plugin['desc'])) {
                        $roofing_specialist_action['desc'] = $roofing_specialist_plugin['desc'];
                    }

                    $roofing_specialist_action['name'] = '';
                    if (isset($roofing_specialist_plugin['name'])) {
                        $roofing_specialist_action['title'] = $roofing_specialist_plugin['name'];
                    }

                    $roofing_specialist_link_and_is_done  = $this->roofing_specialist_get_plugin_buttion($roofing_specialist_plugin['slug'], $roofing_specialist_plugin['name'], $roofing_specialist_plugin['function']);
                    $roofing_specialist_action['link']    = $roofing_specialist_link_and_is_done['button'];
                    $roofing_specialist_action['is_done'] = $roofing_specialist_link_and_is_done['done'];
                    if (!$roofing_specialist_action['is_done'] && (!isset($roofing_specialist_actions_todo[$roofing_specialist_action['id']]) || !$roofing_specialist_actions_todo[$roofing_specialist_action['id']])) {
                        $roofing_specialist_act_count++;
                    }
                    $roofing_specialist_recommended_actions[] = $roofing_specialist_action;
                    $roofing_specialist_actions_todo[]        = array('id' => $roofing_specialist_action['id'], 'watch' => true);
                }
                return array('count' => $roofing_specialist_act_count, 'actions' => $roofing_specialist_recommended_actions);
            }

        }

        public function roofing_specialist_get_recommended_plugins() {

            $roofing_specialist_plugins = apply_filters('roofing_specialist_recommended_plugins', array());
            return $roofing_specialist_plugins;
        }

        public function roofing_specialist_get_plugin_buttion($slug, $name, $function) {
                $roofing_specialist_is_done      = false;
                $roofing_specialist_button_html  = '';
                $roofing_specialist_is_installed = $this->is_plugin_installed($slug);
                $roofing_specialist_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $roofing_specialist_is_activeted = (class_exists($function)) ? true : false;
                if (!$roofing_specialist_is_installed) {
                    $roofing_specialist_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $roofing_specialist_plugin_install_url = wp_nonce_url($roofing_specialist_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $roofing_specialist_button_html        = sprintf('<a class="roofing-specialist-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($roofing_specialist_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'roofing-specialist'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'roofing-specialist')
                    );
                } elseif ($roofing_specialist_is_installed && !$roofing_specialist_is_activeted) {

                    $roofing_specialist_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($roofing_specialist_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $roofing_specialist_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $roofing_specialist_button_html = sprintf('<a class="roofing-specialist-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($roofing_specialist_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'roofing-specialist'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'roofing-specialist')
                    );
                } elseif ($roofing_specialist_is_activeted) {
                    $roofing_specialist_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'roofing-specialist'));
                    $roofing_specialist_is_done     = true;
                }

                return array('done' => $roofing_specialist_is_done, 'button' => $roofing_specialist_button_html);
            }
        public function is_plugin_installed($slug) {
            $roofing_specialist_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $roofing_specialist_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($roofing_specialist_installed_plugins[$roofing_specialist_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $roofing_specialist_keys = array_keys($this->get_installed_plugins());
            foreach ($roofing_specialist_keys as $roofing_specialist_key) {
                if (preg_match('|^' . $slug . '/|', $roofing_specialist_key)) {
                    return $roofing_specialist_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Roofing_Specialist_Plugin_Activation_WPElemento_Importer::get_instance();